/* ==================================================================== */
/* Allan CORNET */
/* DIGITEO 2008 - 2009 */
/* ==================================================================== */
#include "../../src/c/dde.h"
#include "api_scilab.h"
#include "stack-c.h"
#include "MALLOC.h"
#include "localization.h"
#include "Scierror.h"
#include "BOOL.h"
/* ==================================================================== */
int sci_ddeclose(char *fname)
{
  int n1 = 0;
  BOOL *paramoutBool = NULL;
  SciErr sciErr;

  Rhs = Max(0,Rhs);
  CheckRhs(0,0);
  CheckLhs(0,1);

  paramoutBool = (BOOL*)MALLOC(sizeof(BOOL));
  if (paramoutBool == NULL)
  {
    Scierror(999, _("%s: No more memory.\n"),fname) ;
    return 0;
  }

  if ( DDECloseConnection() )
  {
    *paramoutBool = TRUE;
  }
  else
  {
    *paramoutBool = FALSE;
  }

  n1 = 1;
  sciErr = createMatrixOfBoolean(pvApiCtx, Rhs + 1, n1, n1, paramoutBool);

  if (paramoutBool)
  {
    FREE(paramoutBool);
    paramoutBool = NULL;
  }

  if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  }

  LhsVar(1) = Rhs+1;

  return 0;
}
/* ==================================================================== */

