/* ==================================================================== */
/* Allan CORNET */
/* DIGITEO 2008 - 2009 */
/* ==================================================================== */
#include "../../src/c/dde.h"
#include "stack-c.h"
#include "MALLOC.h"
#include "BOOL.h"
#include "Scierror.h"
#include "localization.h"
#include "api_scilab.h"
/* ==================================================================== */
int sci_ddeopen(char *fname)
{
  SciErr sciErr;

  int *piAddressVarOne = NULL;
  int *piAddressVarTwo = NULL;
  int iType1 = 0;
  int iType2 = 0;

  Rhs = Max(0, Rhs);
  CheckRhs(2, 2);
  CheckLhs(0, 1);

  sciErr = getVarAddressFromPosition(pvApiCtx, 1, &piAddressVarOne);
  if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  }

  sciErr = getVarAddressFromPosition(pvApiCtx, 2, &piAddressVarTwo);
  if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  }

  sciErr = getVarType(pvApiCtx, piAddressVarOne, &iType1);
  if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  }

  sciErr = getVarType(pvApiCtx, piAddressVarTwo, &iType2);
  if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  }

  if ( (iType1 == sci_strings) && (iType2 == sci_strings) )
  {
    int n1 = 0, m1 = 0;
    int n2 = 0, m2 = 0;

    char *pStVarOne = NULL;
    int lenStVarOne = 0;

    char *pStVarTwo = NULL;
    int lenStVarTwo = 0;

    BOOL *paramoutBool = NULL;

    sciErr = getMatrixOfString(pvApiCtx, piAddressVarOne,&m1,&n1,&lenStVarOne,&pStVarOne);
    if(sciErr.iErr)
    {
      printError(&sciErr, 0);
      return 0;
    }

    if ( (m1 != n1) && (n1 != 1) )
    {
      Scierror(999,_("%s: Wrong size for input argument #%d: A string expected.\n"),fname,1);
      return 0;
    }

    pStVarOne = (char*)MALLOC(sizeof(char)*(lenStVarOne + 1));
    if (pStVarOne == NULL)
    {
      Scierror(999,_("%s: No more memory.\n"),fname);
      return 0;
    }

    sciErr = getMatrixOfString(pvApiCtx, piAddressVarOne,&m1,&n1,&lenStVarOne,&pStVarOne);
    if(sciErr.iErr)
    {
      FREE(pStVarOne); pStVarOne = NULL;
      printError(&sciErr, 0);
      return 0;
    }

    sciErr = getMatrixOfString(pvApiCtx, piAddressVarTwo,&m2,&n2,&lenStVarTwo,&pStVarTwo);
    if(sciErr.iErr)
    {
      FREE(pStVarOne); pStVarOne = NULL;
      printError(&sciErr, 0);
      return 0;
    }

    if ( (m2 != n2) && (n2 != 1) )
    {
      FREE(pStVarOne); pStVarOne = NULL;
      Scierror(999,_("%s: Wrong size for input argument #%d: A string expected.\n"),fname,2);
      return 0;
    }

    pStVarTwo = (char*)MALLOC(sizeof(char)*(lenStVarTwo + 1));
    if (pStVarTwo == NULL)
    {
      FREE(pStVarOne); pStVarOne = NULL;
      Scierror(999,_("%s: No more memory.\n"),fname);
      return 0;
    }

    sciErr = getMatrixOfString(pvApiCtx, piAddressVarTwo,&m2,&n2,&lenStVarTwo,&pStVarTwo);
    if(sciErr.iErr)
    {
      FREE(pStVarOne); pStVarOne = NULL;
      FREE(pStVarTwo); pStVarTwo = NULL;
      printError(&sciErr, 0);
      return 0;
    }

    paramoutBool = (BOOL*)MALLOC(sizeof(BOOL));
    if (paramoutBool == NULL)
    {
      FREE(pStVarOne); pStVarOne = NULL;
      FREE(pStVarTwo); pStVarTwo = NULL;
      Scierror(999, _("%s: No more memory.\n"),fname) ;
      return 0;
    }

    if ( DDEOpenConnection(pStVarOne, pStVarTwo) )
    {
      paramoutBool[0] = TRUE;
    }
    else
    {
      paramoutBool[0] = FALSE;
    }

    FREE(pStVarOne); pStVarOne = NULL;
    FREE(pStVarTwo); pStVarTwo = NULL;

    n1 = 1;
    sciErr = createMatrixOfBoolean(pvApiCtx, Rhs + 1, n1, n1, paramoutBool);

    if (paramoutBool)
    {
      FREE(paramoutBool);
      paramoutBool = NULL;
    }

    if(sciErr.iErr)
    {
      printError(&sciErr, 0);
      return 0;
    }

    LhsVar(1) = Rhs+1;

  }
  else
  {
    Scierror(999,_("%s: Wrong type for input argument: String expected.\n"),fname);
  }

  return 0;
}
/* ==================================================================== */
